from PyQt5 import QtCore, QtGui, QtSerialPort
from PyQt5.QtGui import QPainter
from PyQt5.QtCore import QPointF,QRectF, Qt, QLineF,  QObject
from PyQt5.QtWidgets import QWidget, QApplication, QStyleFactory, QMainWindow,QGridLayout, QPushButton, QComboBox, QMessageBox, QDialogButtonBox
import sys
import serial



Flag=None
Flag_Two=None
Flag_Three=None

def OpenClose():
    global  Flag
    try:
        global ser
        ser = serial.Serial(COM.currentText(), 115200, timeout=0)
    except:
        pass


    while True:
        if Flag==1:
            try:
                print("Close")
                ser.close()

                COM.setEnabled(True)  # enable comboBox
                Button_CloseOpen.setText("Close COM")
                Button_CloseOpen.setStyleSheet("background-color : red")
                Flag=0
                break
            except:
                ErrorMsg.setText("Error close COM port. \nIf you run Arduino IDE, please close it!")
                ErrorMsg.setWindowTitle("Error")
                ErrorMsg.exec_()
                break

        try:
            print("Open")
            print(ser.name)
            COM.setEnabled(False)  # disable comboBox
            Button_CloseOpen.setStyleSheet("background-color : green")
            Button_CloseOpen.setText("Open COM")

            Flag=1
            break
        except:
            ErrorMsg.setText("Error open COM port. \nIf you run Arduino IDE, please close it!")
            ErrorMsg.setWindowTitle("Error")
            ErrorMsg.exec_()
            break


def SwitchMode():
    global Flag_Two
    if Flag==1:
        while True:
            if Flag_Two == 1:
                joystick.setHidden(False)
                square.setHidden(True)
                Button_Check.setHidden(True)
                SerialSend(4)
                Flag_Two = 0
                break
            joystick.setHidden(True)
            square.setHidden(False)
            Button_Check.setHidden(False)
            Flag_Two = 1
            SerialSend(4)
            CheckColor()
            break


def refresh():
    if Flag==0:
        print("Refresh COM")
        COM.clear()
        SerialPorts.clear()
        ports = QtSerialPort.QSerialPortInfo().availablePorts()
        for port in ports:
            port_name = port.portName()
            SerialPorts.append(port_name)

        for i in SerialPorts:
            COM.addItem(i)

def SerialSend(Command):
    if Flag==1:
        print(Command)
        try:
            if Command==0:
                ser.write(b'0')
            if Command==1:
                ser.write(b'1')
            if Command==2:
                ser.write(b'2')
            if Command==3:
                ser.write(b'3')
            if Command==4:
                ser.write(b'4')
            if Command==5:
                ser.write(b'5')
            if Command==6:
                ser.write(b'6')
            if Command==7:
                ser.write(b'7')
            if Command==8:
                ser.write(b'8')
            if Command==9:
                ser.write(b'9')
            if Command==10:
                ser.write(b'10')
            if Command==11:
                ser.write(b'11')
            if Command==12:
                ser.write(b'12')
        except:
            ErrorMsg.setText("Error send message to COM port. \nIf you run Arduino IDE, please close it!")
            ErrorMsg.setWindowTitle("Error")
            ErrorMsg.exec_()


def CheckColor():
    if Flag==1:
        print("CHECK")
        SerialSend(6)
        color = ser.readline()
        print(color)
        square.setStyleSheet(f"background-color: {color}" )

def Seizure():
    SerialSend(7)

def Safe():
    SerialSend(8)

def Delete_last():
    SerialSend(9)

def Delete_ALL():
    button_msg=WaitASecond.exec()
    if button_msg == QMessageBox.Yes:
        print("OK!")
        SerialSend(12)


def Replay():
    global Flag_Three
    global Flag

    if Flag == 1:
        while True:


            if Flag_Three==1:
                SerialSend(11)
                Replay_Button.setText("OFF Replay")
                Replay_Button.setStyleSheet("background-color : red")
                Flag_Three = 0
                break
            SerialSend(10)
            Replay_Button.setStyleSheet("background-color : green")
            Replay_Button.setText("ON Replay")
            Flag_Three = 1
            break

            if Flag_Three==1:

                Replay_Button.setText("OFF Replay")
                Replay_Button.setStyleSheet("background-color : red")
                Flag_Three = 0
                break


class Joystick(QWidget):
    def __init__(self, parent=None):
        super(Joystick, self).__init__(parent)
        self.setMinimumSize(100, 100)
        self.movingOffset = QPointF(0, 0)
        self.grabCenter = False
        self.__maxDistance = 50

    def paintEvent(self, event):
        painter = QPainter(self)
        bounds = QRectF(-self.__maxDistance, -self.__maxDistance, self.__maxDistance * 2,
                        self.__maxDistance * 2).translated(self._center())
        painter.drawEllipse(bounds)
        painter.setBrush(Qt.black)
        painter.drawEllipse(self._centerEllipse())

    def _centerEllipse(self):
        if self.grabCenter:
            return QRectF(-20, -20, 40, 40).translated(self.movingOffset)
        return QRectF(-20, -20, 40, 40).translated(self._center())

    def _center(self):
        return QPointF(self.width() / 2, self.height() / 2)

    def _boundJoystick(self, point):
        limitLine = QLineF(self._center(), point)
        if (limitLine.length() > self.__maxDistance):
            limitLine.setLength(self.__maxDistance)
        return limitLine.p2()

    def joystickDirection(self):
        if not self.grabCenter:
            return 0
        normVector = QLineF(self._center(), self.movingOffset)
        currentDistance = normVector.length()
        angle = normVector.angle()

        distance = min(currentDistance / self.__maxDistance, 1.0)
        if 45 <= angle < 135:
            return (0)
        elif 135 <= angle < 225:
            return (1)
        elif 225 <= angle < 315:
            return (2)
        return (3)

    def mousePressEvent(self, ev):
        self.grabCenter = self._centerEllipse().contains(ev.pos())
        return super().mousePressEvent(ev)

    def mouseReleaseEvent(self, event):
        SerialSend(5)
        self.grabCenter = False
        self.movingOffset = QPointF(0, 0)
        self.update()

    def mouseMoveEvent(self, event):
        if self.grabCenter:

            self.movingOffset = self._boundJoystick(event.pos())
            self.update()
            SerialSend(self.joystickDirection())




if __name__ == '__main__':

    # Create main application window
    app = QApplication([])
    app.setStyle(QStyleFactory.create("Fusion"))
    mw = QMainWindow()
    mw.setWindowTitle('manipulator control')
    mw.setWindowIcon(QtGui.QIcon("6249-ustanovka-po-izucheniyu-robo-transformed.png"))
    # Create and set widget layout
    # Main widget container
    cw = QWidget()
    ml = QGridLayout()
    cw.setLayout(ml)
    mw.setFixedWidth(255)
    mw.setFixedHeight(250)
    mw.setCentralWidget(cw)
    SerialPorts = list()

    ports = QtSerialPort.QSerialPortInfo().availablePorts()
    for port in ports:
        port_name = port.portName()
        SerialPorts.append(port_name)

    # Create joystick
    joystick = Joystick()



    # create buttons
    Button_Switch = QPushButton("Switch mode")
    Button_Switch.clicked.connect(SwitchMode)

    Button_CloseOpen = QPushButton("Open COM")
    Button_CloseOpen.clicked.connect(OpenClose)


    Button_Check=QPushButton("Check Color")
    Button_Check.clicked.connect(CheckColor)
    Button_Check.setHidden(True)



    Button_Refresh = QPushButton("Refresh COM")
    Button_Refresh.clicked.connect(refresh)

    Seizure_Button=QPushButton("Seizure")
    Seizure_Button.clicked.connect(Seizure)

    Replay_Button= QPushButton('Replay')
    Replay_Button.clicked.connect(Replay)

    Safe_Button=QPushButton('Safe')
    Safe_Button.clicked.connect(Safe)

    Delete_Button=QPushButton('Delete')
    Delete_Button.clicked.connect(Delete_last)

    DeleteALL_Button=QPushButton('Delete ALL')
    DeleteALL_Button.clicked.connect(Delete_ALL)

    # create ComboBox
    COM = QComboBox()
    for i in SerialPorts:
        COM.addItem(i)

    #create button CHANGE COLOR
    square=QPushButton()
    square.setFixedSize(100,105)
    square.setHidden(True)




    #create Error Message

    ErrorMsg = QMessageBox()
    ErrorMsg.setIcon(QMessageBox.Critical)

    WaitASecond=QMessageBox()
    WaitASecond.setWindowTitle('WARNING!')
    WaitASecond.setStandardButtons(QMessageBox.Yes | QMessageBox.No)
    WaitASecond.setText('Are you sure you want to delete the ENTIRE program?')




    # add widgets
    ml.addWidget(Button_Switch, 23, 0)
    ml.addWidget(Button_Refresh, 27, 52)
    ml.addWidget(Button_CloseOpen, 21, 52)
    ml.addWidget(COM, 0, 52)
    ml.addWidget(joystick, 0, 0)
    ml.addWidget(square, 0, 0)
    ml.addWidget(Button_Check,16, 0)
    ml.addWidget(Seizure_Button, 21,0)
    ml.addWidget(Replay_Button, 23, 52)
    ml.addWidget(DeleteALL_Button, 25, 52)
    ml.addWidget(Safe_Button, 25,0)
    ml.addWidget(Delete_Button, 27, 0)


    mw.setCentralWidget(cw)
    mw.show()

    # Start Qt event loop unless running in interactive mode or using pyside.
    if (sys.flags.interactive != 1) or not hasattr(QtCore, 'PYQT_VERSION'):
        QApplication.instance().exec_()
